package com.unitesk.requality.libreoffice.api.impls;

import java.io.IOException;
import java.util.List;

import com.unitesk.requality.libreoffice.api.APIClient;
import com.unitesk.requality.libreoffice.api.requests.ProjectsListRequest;

public class API {
	private APIClient client;
	
	public API(APIClient client) {
		this.client = client;
	}
	
	public List<String> getProjects() throws IOException {
		return client.execute(new ProjectsListRequest()).getProjects();
	}
	
	public boolean projectExists(String project) throws IOException {
		return getProjects().contains(project);
	}
	
	public ProjectAPI getProject(String project) throws IOException {
		return new ProjectAPI(client, project);
	}
	
	public static API get() throws IOException {
		return new API(APIClient.get());
	}
}
