package com.unitesk.requality.libreoffice.api.requests;

import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

import javax.xml.bind.DatatypeConverter;

import com.unitesk.requality.libreoffice.api.APIRequest;
import com.unitesk.requality.libreoffice.api.HTTPMethod;
import com.unitesk.requality.libreoffice.api.responses.PingResponse;

public class PingRequest extends APIRequest<PingResponse> {
	private int foo;
	private String bar;
	
	public PingRequest(int foo, String bar) {
		this.foo = foo;
		this.bar = bar;
	}

	public int getFoo() {
		return foo;
	}

	public String getBar() {
		return bar;
	}

	public boolean matches(PingResponse resp) {
		return foo == resp.getFoo() && bar.equals(resp.getBar());
	}
	
	@Override
	public Class<PingResponse> responseClass() {
		return PingResponse.class;
	}

	@Override
	public String requestURL() {
		return "/misc/ping";
	}

	@Override
	public HTTPMethod method() {
		return HTTPMethod.POST;
	}
	
	public static PingRequest random() {
		Random rng = ThreadLocalRandom.current();
		byte[] barBytes = new byte[16];
		rng.nextBytes(barBytes);
		return new PingRequest(rng.nextInt(), DatatypeConverter.printHexBinary(barBytes).toUpperCase());
	}
}
