package com.unitesk.requality.libreoffice.api.requests;

import java.util.UUID;

import com.fasterxml.jackson.databind.node.TextNode;
import com.unitesk.requality.libreoffice.api.APIRequest;
import com.unitesk.requality.libreoffice.api.HTTPMethod;

public class RequirementExportRequest extends APIRequest<TextNode> {
	private String project;
	private UUID requirement;

	public RequirementExportRequest(String project, UUID requirement) {
		this.project = project;
		this.requirement = requirement;
	}

	public String getProject() {
		return project;
	}

	public UUID getRequirement() {
		return requirement;
	}

	@Override
	public Class<TextNode> responseClass() {
		return TextNode.class;
	}

	@Override
	public String requestURL() {
		return "/projects/" + urlencode(project) + "/requirements/" + urlencode(requirement.toString()) + "/export";
	}

	@Override
	public HTTPMethod method() {
		return HTTPMethod.GET;
	}
}
