package com.unitesk.requality.libreoffice.api.requests;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.unitesk.requality.libreoffice.api.APIRequest;
import com.unitesk.requality.libreoffice.api.HTTPMethod;
import com.unitesk.requality.libreoffice.api.models.JsonEmpty;

public class RequirementImportRequest extends APIRequest<JsonEmpty> {
	private String project;
	private String html;
	
	public RequirementImportRequest(String project, String html) {
		this.project = project;
		this.html = html;
	}

	@JsonIgnore
	public String getProject() {
		return project;
	}

	public String getHtml() {
		return html;
	}

	@Override
	public Class<JsonEmpty> responseClass() {
		return JsonEmpty.class;
	}

	@Override
	public String requestURL() {
		return "/projects/" + urlencode(project) + "/import";
	}

	@Override
	public HTTPMethod method() {
		return HTTPMethod.POST;
	}
}
