package com.unitesk.requality.libreoffice.api.requests;

import com.unitesk.requality.libreoffice.api.APIRequest;
import com.unitesk.requality.libreoffice.api.HTTPMethod;
import com.unitesk.requality.libreoffice.api.models.IDTree;

public class RequirementsTreeRequest extends APIRequest<IDTree> {
	private String project;
	
	public RequirementsTreeRequest(String project) {
		this.project = project;
	}

	@Override
	public Class<IDTree> responseClass() {
		return IDTree.class;
	}

	@Override
	public String requestURL() {
		return "/projects/" + urlencode(project) + "/requirements/tree";
	}

	@Override
	public HTTPMethod method() {
		return HTTPMethod.GET;
	}

}
