package com.unitesk.requality.libreoffice.api.requests;

import java.util.UUID;

import com.unitesk.requality.libreoffice.api.APIRequest;
import com.unitesk.requality.libreoffice.api.HTTPMethod;
import com.unitesk.requality.libreoffice.api.models.JsonEmpty;

public class ViewNodeRequest extends APIRequest<JsonEmpty> {
	private String project;
	private UUID uuid;

	public ViewNodeRequest(String project, UUID uuid) {
		this.project = project;
		this.uuid = uuid;
	}

	@Override
	public Class<JsonEmpty> responseClass() {
		return JsonEmpty.class;
	}

	@Override
	public String requestURL() {
		return "/projects/" + project + "/nodes/" + uuid + "/view";
	}

	@Override
	public HTTPMethod method() {
		return HTTPMethod.POST;
	}

}
