package com.unitesk.requality.libreoffice.ui;

import javax.swing.JDialog;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

import javax.swing.JLabel;

import java.awt.Insets;

import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JPanel;

import java.awt.FlowLayout;
import java.net.URL;

public class APISetupDialog extends JDialog {
	private static final long serialVersionUID = 1L;

	private JTextField baseURLField;
	private JTextField apiKeyField;
	private boolean cancelled = true;

	public APISetupDialog(String promptText, URL baseURL, String apiKey) {
		super((JDialog) null, "Connect to Requality", ModalityType.APPLICATION_MODAL);
		setResizable(false);
		setTitle("Connect to Requality");
		setSize(504, 193);
		
		GridBagLayout mainLayout = new GridBagLayout();
		mainLayout.columnWidths = new int[] {0, 0, 0};
		mainLayout.rowHeights = new int[]{0, 0, 0, 0};
		mainLayout.columnWeights = new double[]{0.0, 0.0, 1.0};
		mainLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0};
		getContentPane().setLayout(mainLayout);
		
		ImagePanel imagePanel = new ImagePanel("/com/unitesk/requality/error_icon.png");
		GridBagConstraints gbc_imagePanel = new GridBagConstraints();
		gbc_imagePanel.anchor = GridBagConstraints.NORTH;
		gbc_imagePanel.gridheight = 4;
		gbc_imagePanel.insets = new Insets(0, 10, 0, 20);
		gbc_imagePanel.gridx = 0;
		gbc_imagePanel.gridy = 0;
		getContentPane().add(imagePanel, gbc_imagePanel);
		
		JLabel lblNewLabel = new JLabel("<html>" + promptText + "</html>");
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.insets = new Insets(0, 0, 5, 10);
		gbc_lblNewLabel.gridwidth = 2;
		gbc_lblNewLabel.weightx = 999999.0;
		gbc_lblNewLabel.fill = GridBagConstraints.HORIZONTAL;
		gbc_lblNewLabel.gridx = 1;
		gbc_lblNewLabel.gridy = 0;
		getContentPane().add(lblNewLabel, gbc_lblNewLabel);
		
		JLabel lblNewLabel_1 = new JLabel("API server");
		GridBagConstraints gbc_lblNewLabel_1 = new GridBagConstraints();
		gbc_lblNewLabel_1.anchor = GridBagConstraints.EAST;
		gbc_lblNewLabel_1.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_1.gridx = 1;
		gbc_lblNewLabel_1.gridy = 1;
		getContentPane().add(lblNewLabel_1, gbc_lblNewLabel_1);
		
		baseURLField = new JTextField(baseURL.toString());
		GridBagConstraints gbc_textField = new GridBagConstraints();
		gbc_textField.insets = new Insets(0, 0, 5, 10);
		gbc_textField.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField.gridx = 2;
		gbc_textField.gridy = 1;
		getContentPane().add(baseURLField, gbc_textField);
		baseURLField.setColumns(10);
		
		JLabel lblNewLabel_2 = new JLabel("API key");
		GridBagConstraints gbc_lblNewLabel_2 = new GridBagConstraints();
		gbc_lblNewLabel_2.insets = new Insets(0, 0, 5, 5);
		gbc_lblNewLabel_2.anchor = GridBagConstraints.EAST;
		gbc_lblNewLabel_2.gridx = 1;
		gbc_lblNewLabel_2.gridy = 2;
		getContentPane().add(lblNewLabel_2, gbc_lblNewLabel_2);
		
		apiKeyField = new JTextField(apiKey);
		GridBagConstraints gbc_textField_1 = new GridBagConstraints();
		gbc_textField_1.insets = new Insets(0, 0, 5, 10);
		gbc_textField_1.fill = GridBagConstraints.HORIZONTAL;
		gbc_textField_1.gridx = 2;
		gbc_textField_1.gridy = 2;
		getContentPane().add(apiKeyField, gbc_textField_1);
		apiKeyField.setColumns(10);
		
		JPanel panel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panel.getLayout();
		flowLayout.setAlignment(FlowLayout.RIGHT);
		GridBagConstraints gbc_panel = new GridBagConstraints();
		gbc_panel.gridwidth = 2;
		gbc_panel.insets = new Insets(0, 0, 0, 10);
		gbc_panel.fill = GridBagConstraints.BOTH;
		gbc_panel.gridx = 1;
		gbc_panel.gridy = 3;
		getContentPane().add(panel, gbc_panel);
		
		JButton btnCancel = new JButton("Cancel");
		panel.add(btnCancel);
		
		btnCancel.addActionListener(e -> dispose());
		
		JButton btnOk = new JButton("OK");
		panel.add(btnOk);
		
		btnOk.addActionListener(e -> { cancelled = false; dispose(); });
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	public String getBaseURL() {
		return baseURLField.getText();
	}
	
	public String getApiKey() {
		return apiKeyField.getText();
	}
	
	public boolean isCancelled() {
		return cancelled;
	}
}
