package com.unitesk.requality.libreoffice.ui;

import javax.swing.JDialog;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

import javax.swing.JLabel;

import java.awt.Insets;

import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JButton;

import java.io.PrintWriter;
import java.io.StringWriter;

public class ExceptionDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	private JTextArea exceptionText;
	
	public ExceptionDialog(Exception exc) {
		super((JDialog) null, "Unexpected exception", ModalityType.APPLICATION_MODAL);
		setSize(466, 356);
		
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 1.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 1.0, 0.0, Double.MIN_VALUE};
		getContentPane().setLayout(gridBagLayout);
		
		ImagePanel imagePanel = new ImagePanel("/com/unitesk/requality/error_icon.png");
		GridBagConstraints gbc_imagePanel = new GridBagConstraints();
		gbc_imagePanel.gridheight = 2;
		gbc_imagePanel.insets = new Insets(10, 10, 0, 5);
		gbc_imagePanel.fill = GridBagConstraints.BOTH;
		gbc_imagePanel.gridx = 0;
		gbc_imagePanel.gridy = 0;
		getContentPane().add(imagePanel, gbc_imagePanel);
		
		JLabel lblNewLabel = new JLabel("An unexpected exception has been occured:");
		GridBagConstraints gbc_lblNewLabel = new GridBagConstraints();
		gbc_lblNewLabel.anchor = GridBagConstraints.WEST;
		gbc_lblNewLabel.insets = new Insets(10, 0, 5, 10);
		gbc_lblNewLabel.gridx = 1;
		gbc_lblNewLabel.gridy = 0;
		getContentPane().add(lblNewLabel, gbc_lblNewLabel);
		
		JScrollPane scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.insets = new Insets(0, 0, 10, 10);
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 1;
		gbc_scrollPane.gridy = 1;
		getContentPane().add(scrollPane, gbc_scrollPane);
		
		exceptionText = new JTextArea();
		initExceptionText(exc);
		scrollPane.setViewportView(exceptionText);
		
		JButton btnNewButton = new JButton("OK");
		btnNewButton.addActionListener(e -> dispose());
		
		GridBagConstraints gbc_btnNewButton = new GridBagConstraints();
		gbc_btnNewButton.insets = new Insets(0, 0, 10, 10);
		gbc_btnNewButton.anchor = GridBagConstraints.EAST;
		gbc_btnNewButton.gridwidth = 2;
		gbc_btnNewButton.gridx = 0;
		gbc_btnNewButton.gridy = 2;
		getContentPane().add(btnNewButton, gbc_btnNewButton);
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private void initExceptionText(Exception exc) {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw, true);
		exc.printStackTrace(pw);
		pw.flush();
		exceptionText.setText(sw.toString());
	}
}
