package com.unitesk.requality.libreoffice.ui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;

import javax.imageio.ImageIO;
import javax.swing.JPanel;

public class ImagePanel extends JPanel {
	private static final long serialVersionUID = 1L;

	private BufferedImage image;
	
	public ImagePanel(String imageName) {
		try (InputStream is = getClass().getResourceAsStream(imageName)) {
			image = ImageIO.read(is);
		} catch (IOException e) {
			throw new RuntimeException("Failed to load image", e);
		}
		
		Dimension imageSize = new Dimension(image.getWidth(), image.getHeight());
		setMinimumSize(imageSize);
		setPreferredSize(imageSize);
		setMaximumSize(imageSize);
		
		setOpaque(true);
	}

	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		g.drawImage(image, 0, 0, this);
	}
}
