package com.unitesk.requality.libreoffice.ui;

import java.util.List;

import javax.swing.JDialog;

import java.awt.GridBagLayout;

import javax.swing.JComboBox;

import java.awt.GridBagConstraints;

import javax.swing.JLabel;

import java.awt.Insets;

import javax.swing.JPanel;
import javax.swing.JButton;

import java.awt.FlowLayout;

public class ProjectSelectionDialog extends JDialog {
	private static final long serialVersionUID = 1L;

	private boolean cancelled = true;
	private JComboBox<String> projectComboBox;
	
	public ProjectSelectionDialog(List<String> availableProjects) {
		super((JDialog) null, "Select current project", ModalityType.APPLICATION_MODAL);
		setResizable(false);
		setSize(451, 156);
		
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0};
		gridBagLayout.columnWeights = new double[]{0.0, 1.0};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0};
		getContentPane().setLayout(gridBagLayout);
		
		JLabel lblSelectRoot = new JLabel("Select current project:");
		GridBagConstraints gbc_lblSelectRoot = new GridBagConstraints();
		gbc_lblSelectRoot.insets = new Insets(0, 20, 5, 5);
		gbc_lblSelectRoot.anchor = GridBagConstraints.EAST;
		gbc_lblSelectRoot.gridx = 0;
		gbc_lblSelectRoot.gridy = 0;
		getContentPane().add(lblSelectRoot, gbc_lblSelectRoot);
		
		projectComboBox = new JComboBox<String>(availableProjects.toArray(new String[availableProjects.size()]));
		GridBagConstraints gbc_projectComboBox = new GridBagConstraints();
		gbc_projectComboBox.insets = new Insets(0, 0, 5, 20);
		gbc_projectComboBox.fill = GridBagConstraints.HORIZONTAL;
		gbc_projectComboBox.gridx = 1;
		gbc_projectComboBox.gridy = 0;
		getContentPane().add(projectComboBox, gbc_projectComboBox);
		
		JPanel panel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panel.getLayout();
		flowLayout.setAlignment(FlowLayout.RIGHT);
		GridBagConstraints gbc_panel = new GridBagConstraints();
		gbc_panel.insets = new Insets(10, 20, 0, 20);
		gbc_panel.gridwidth = 2;
		gbc_panel.fill = GridBagConstraints.BOTH;
		gbc_panel.gridx = 0;
		gbc_panel.gridy = 1;
		getContentPane().add(panel, gbc_panel);
		
		JButton btnCancel = new JButton("Cancel");
		panel.add(btnCancel);
		btnCancel.addActionListener(e -> dispose());
		
		JButton btnOk = new JButton("OK");
		panel.add(btnOk);
		btnOk.addActionListener(e -> { cancelled = false; dispose(); });
		
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	public boolean isCancelled() {
		return cancelled;
	}
	
	public String getProject() {
		return projectComboBox.getItemAt(projectComboBox.getSelectedIndex());
	}
}
